/* 
 * IO fonction
 */
 
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <stdlib.h>
#include "IO.h"

int iTTY(void)
{
	
	/* 
	 * Init TTY
	 */
	
	struct termios ios;
	int fd;

    if ((fd = open(DEFAULT_TTY, O_RDWR)) < 0)  // open it
    {
		perror("open");
		exit(1);
    }

	// configure it

	memset(&ios, 0, sizeof(ios));
	ios.c_cflag = CREAD | CLOCAL | CS8 | PARENB | PARODD;
    cfsetispeed(&ios, B2400);
    cfsetospeed(&ios, B2400);

    if (tcsetattr(fd, TCSANOW, &ios) == -1) 
    {
		perror("tcsetattr");
		exit(1);
	}
	return fd;
}

void send(unsigned char code[10],int lenght, int fd)
{

	/*
	 * Send RCX message function
	 */        	
	        
	int d;

	unsigned char buffer[20];

    buffer[0] = 0x55;  // headers
    buffer[1] = 0xff;
    buffer[2] = 0x00;

	for(d=0; d<lenght; d++)
	{
		buffer[(2*d)+3] = code[d];
		buffer[(2*d)+4] = 0xFF - code[d];
	}
        
    buffer[3+(2*lenght)] = 0x00;
        
	for(d=0; d<lenght; d++)
		buffer[3+(2*lenght)] = code[d]+buffer[3+(2*lenght)];
			
	buffer[4+(2*lenght)]=0xFF - buffer[3+(2*lenght)];
        
	for(d=0; d<(2*lenght)+5; d++)
		printf("%X - ", buffer[d]);
        	
        	
	printf("\n");

	write(fd, buffer, (2*lenght)+5);
}